#include"passphrasedlg.h"

#include<qlineedit.h>
#include<qradiobutton.h>
#include<qpushbutton.h>

PassphraseDlg::PassphraseDlg(QWidget *parent, const char *name)
:PassphraseUI(parent, name, true, WDestructiveClose)
{
	connect(pb_ok, SIGNAL(clicked()), SLOT(doOK()));
	connect(pb_cancel, SIGNAL(clicked()), SLOT(reject()));
	resize(minimumSize());
}

PassphraseDlg::~PassphraseDlg()
{
}

QString PassphraseDlg::passphrase() const
{
	return le_pass->text();
}

void PassphraseDlg::reject()
{
	rejectPassphrase();
	QDialog::reject();
}

void PassphraseDlg::doOK()
{
	le_pass->setEnabled(false);
	pb_ok->setEnabled(false);

	submitPassphrase(le_pass->text());
}

void PassphraseDlg::unblock()
{
	le_pass->setText("");
	le_pass->setEnabled(true);
	pb_ok->setEnabled(true);
	le_pass->setFocus();
}
